%define major 3
%define minor 6
%define fix 0

Name: protobuf
Version: %{major}.%{minor}.%{fix}
Release: 2
License: BSD-3-Clause
Summary: Protocol Buffers - Google's data interchange format
Url: https://developers.google.com/protocol-buffers/

Source0: https://github.com/google/protobuf/releases/download/v%{version}/protobuf-all-%{version}.tar.gz

BuildRequires: zlib-devel
BuildRequires: pase-build-tools

Requires: libprotobuf%{major} = %{version}

%description
Protocol Buffers (a.k.a., protobuf) are Google's language-neutral, platform-neutral, extensible mechanism for serializing structured data. 



# libprotobuf.so.3
%package -n libprotobuf%{major}
Summary: %{summary}

%description -n libprotobuf%{major}
libprotobuf is a data interchange format



# libprotobuf-lite.so.3
%package -n libprotobuf-lite%{major}
Summary: %{summary}

%description -n libprotobuf-lite%{major}
libprotobuf is a data interchange format


# libprotoc.so.3
%package -n libprotoc%{major}
Summary: %{summary}

%description -n libprotoc%{major}
libprotobuf is a data interchange format


# libproto*.so and header files
%package devel
Summary: Protobuf development files
Requires: libprotobuf%{major} = %{version}
Requires: libprotobuf-lite%{major} = %{version}
Requires: libprotoc%{major} = %{version}

%description devel
Protobuf development files

%prep

%setup -q -n protobuf-%{version}

%build

./configure --prefix=%{_prefix} \
  CXXFLAGS="-fPIC" \
  CXX_FOR_BUILD="g++ -fPIC -pthread" \
  LDFLAGS="-Wl,-bbigtoc -Wl,-brtl -Wl,-blibpath:%{_libdir}:/QOpenSys/usr/lib"

%install
gmake install DESTDIR=%{buildroot} -j4

LOADOPTS="-Wl,-blibpath:%{_libdir}:/QOpenSys/usr/lib"
LDFLAGS="-Wl,-bbigtoc -Wl,-brtl $LOADOPTS -L%{_libdir}"

CC=g++ static-to-shared libprotobuf-lite.so.%{major} ./src/.libs/libprotobuf-lite.a $LOADOPTS "-pthread"
CC=g++ static-to-shared libprotobuf.so.%{major} ./src/.libs/libprotobuf.a $LOADOPTS "-pthread" "-lz"
CC=g++ static-to-shared libprotoc.so.%{major} ./src/.libs/libprotoc.a ./libprotobuf.so.%{major} $LOADOPTS "-pthread"

g++ -fPIC -pthread -Wl,-bbigtoc $LDFLAGS -o %{buildroot}%{_bindir}/protoc ./src/google/protobuf/compiler/main.o ./libprotobuf.so.%{major} ./libprotoc.so.%{major}

cp *.so.%{major} %{buildroot}%{_libdir}

ln -s libprotobuf-lite.so.%{major} %{buildroot}%{_libdir}/libprotobuf-lite.so
ln -s libprotobuf.so.%{major} %{buildroot}%{_libdir}/libprotobuf.so
ln -s libprotoc.so.%{major} %{buildroot}%{_libdir}/libprotoc.so

rm %{buildroot}%{_libdir}/*.a
rm %{buildroot}%{_libdir}/*.la

%files
%defattr(-, qsys, *none)
%{_bindir}/protoc


%files -n libprotobuf%{major}
%defattr(-, qsys, *none)
%{_libdir}/libprotobuf.so.%{major}*


%files -n libprotobuf-lite%{major}
%defattr(-, qsys, *none)
%{_libdir}/libprotobuf-lite.so.%{major}*


%files -n libprotoc%{major}
%defattr(-, qsys, *none)
%{_libdir}/libprotoc.so.%{major}*


%files devel
%defattr(-, qsys, *none)
%{_includedir}/google/protobuf/*
%{_libdir}/*.so
%{_libdir}/pkgconfig/*

%changelog
* Mon Jun 10 2019 - Xu Meng <mengxumx@cn.ibm.com>
- Create separate packages for each library

* Wed Mar 27 2019 - Xu Meng <mengxumx@cn.ibm.com>
- Remove redundant directories

* Mon Mar 18 2019 - Xu Meng <mengxumx@cn.ibm.com>
- Initial commit